<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Author: Olaf Herfurth / TerraProject  http://www.tecmu.de
 *
 * $Revision: 17 $
 * $Author: PragmaMx $
 * $Date: 2021-02-25 09:08:28 +0100 (Do, 25. Feb 2021) $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radmincontent')) {
    mxErrorScreen('Access Denied');
    die();
}


$module_name=basename(dirname(dirname(__FILE__)));

mxGetLangfile($module_name);

$mypath=PMX_MODULES_PATH . $module_name .DS;

include_once($mypath."includes".DS."functions.php");


class mxSlider 
{
	var $config=array();
	var $_modul = NULL;
	var $_table="";
	var $_tablename="";
	
	/**
	 *  __construct 
	 *  
	 *  @param [in] $act 
	 *  @param [in] $id  
	 *  @return 
	 *  
	 *  Date: 2021-03-09T11:18:13 
	 *  created by : Olaf Herfurth 
	 */
	 function __construct($act,$id)
	{
		global $module_name;
		$this->_modul=$module_name;
		$this->_tablename=PMXSLIDER_TABLE;
		pmxSlider_install();		
		
		$cfg = load_class('Config',$this->_modul);
		$section= $cfg->getSection($this->_modul);
		$conf=$this->_default_config();
		//$this->_tablename=pmxBase::prefix().$this->_table;
		$this->config=array_merge($conf,$section);
		//mxDebugFuncVars($this->config);
		
		switch ($act)
		{
			case "config":
			$this->settings($act,$id);
			break;
			case "edit":
			$this->edit($act,$id);
			break;
			case "delete":
			$this->delete($act,$_POST);
			break;

		}

		$this->main($act,$id);
	}
	/**
	 *  main 
	 *  
	 *  @param [in] $act 
	 *  @param [in] $id  
	 *  @return 
	 *  
	 *  Date: 2021-03-09T11:18:24 
	 *  created by : Olaf Herfurth 
	 */
	function main($act,$id)
	{
		global $module_name;
		
		$error="";
		$info=$module_name;
		$form="";
		$tb = load_class('AdminForm', "adminFormMain");
		
		switch ($act)
		{
			case "activate":
				$id=intval($id);
				$this->_activate($id);
				break;
			case "deactivate":
				$id=intval($id);
				$this->_deactivate($id);
				break;
		}
		
		/* Auswertung Formular */
		 switch (pmxAdminForm::CheckButton()) {
			case "add":
				$this->edit($act,0);
			break;
			case "config":
				$this->settings($act);
				die();
				break;
			case "delete":
			    $cid=$_POST['cid'];
				$this->delete("",$cid);
				die();
				break;			
          case "save":
                foreach($_POST['subposition'] as $nr=>$value){
                    $this->_updatePosition($nr,$value);
                }
				$this->_renumPosition();
                break;
			case "preview":
			  $this->preview();
			  die();
			break;		 }	 		
		
		/* Formular */
		
		$tb->__set("tb_text", "");
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 30);
		$tb->__set("cssclass", "toolbar1");
		$tb->__set('homelink', false);
		$tb->__set("toolbarfixed", false);

		//$tb->addToolbar("publishX");
		//$tb->addToolbar("unpublishX");
		$tb->addToolbar("add");
		$tb->addToolbar("preview");
		$tb->addToolbar("deleteX");
		$tb->addToolbar("config");
		
		/* Daten holen */
        $fieldname=array(
		    array("name"=>mxText('_IMAGE'),"attr"=>"style='width:120px'"),
            array("name"=>mxText('_TITLE'),"attr"=>"style='min-width:100px'"),
            array("name"=>mxText('_SUBTITLE'),"attr"=>"style='width:auto'"),
            array("name"=>mxText('_PICTURE'),"attr"=>"style='min-width:100px'"),

            array("name"=>mxText("_LINK"),"attr"=>"style='width:100px'"),
            array("name"=>mxText("_ACTIVE"),"attr"=>"style='width:50px'"),
            array("name"=>''._POSITION.'&nbsp;<button type="submit" value="save" name="toolbarsubmit" onclick="javascript:hideMainMenu();" title="'._POSITION.'"> <img src="'.$tb->get_action_pic('save').'" title="'._POSITION.'" alt="'._POSITION.'" style="width:16px" /></button>',"attr"=>"style='width:60px'"),
            
            );		
		$records=sql_query("SELECT * FROM `".$this->_tablename."` ORDER by position ASC");
		
		$values=array();
		$img_activate = mxCreateImage('images/adminform/accept.png', _ACTIVATE, array('title' => _DEACTIVATE,"style"=>'width:16px;height:16px;'));
		$img_deactivate = mxCreateImage('images/adminform/cancel.png', _DEACTIVATE, array('title' => _ACTIVATE,"style"=>'width:16px;height:16px;'));
		
		foreach ($records as $record)
		{
			$record1=$this->_default_record();
			$value=array_merge($record1,$record);
			
			$action_set=
                    '<a href="admin.php?op='.$module_name.'&amp;act='.(($value['active']==0)?"activate":"deactivate").'&amp;id='.$value['nr'].'" title="">'.
					(($value['active']==0)?$img_deactivate:$img_activate).'</a>&nbsp;';
			
		   $values[$value['nr']]=array(
				"<a href='".$value['image']."' rel='pretty[slider]' title='".mxStripSlashes($value['title'])."'><img src='".$value['image']."' style='width:100px;max-height:100px;' /></a>",
				"<a href='admin.php?op=".$module_name."&act=edit&id=".$value['nr']."'>".mxStripSlashes($value['title'])."</a>",
				mxStripSlashes($value['subtitle']),
				mxStripSlashes($value['image']),
				mxStripSlashes($value['link']),
				//($value['active']?$img_activate:$img_deactivate),
				$action_set,
				"<input type='number' name='subposition[".$value['nr']."]' value='".$value['position']."' maxlength='3' size='3' min='-1' max='999' step='1'/>",
			);
		}
		$tb->add("","table",$fieldname,$values);
		$form= $tb->Show();
		$credits= mxcredit_shortinfo_string("modules".DS . $module_name. DS."setup.pmx.php");
		
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->init_path(__FILE__);

		/* hier die Ausgabefelder angeben */
		
		//include(PMX_MODULES_PATH . $module_name .DS."setup.pmx.php");

		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info', 'module_name','error','credits'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.config.html');

		mxIncludeFooter();
	}
	
	/**
	 *  settings 
	 *  
	 *  @param [in] $act 
	 *  @return 
	 *  
	 *  Date: 2021-03-09T11:18:56 
	 *  created by : Olaf Herfurth 
	 */
	function settings($act)
	{
		global $module_name;
		$error="";
		$redirectflag=false;
		
		$info=$module_name;
		$form="";
		$tb = load_class('AdminForm', "adminFormMain");
		$stype=5;
		
		$slider=$this->config['slider'];
		
		/* Auswertung Formular */
		
		 switch (pmxAdminForm::CheckButton()) {
			case "cpanel":
				$act="";
				$id=0;
				$this->main($act,$id);
			break;
			case "save":
				$redirectflag=true;
			case "accept":
				$slider=$_POST['slider'];
				$this->config['slider']=$slider;
				$config = load_class('Config',$module_name);
				$config->setSection($module_name,$this->config);
				if ($redirectflag) mxRedirect("admin.php?op=$module_name", _CHANGESAREOK, 0);
			break;
			case "preview":
			  $this->preview();
			  die();
			break;		 
		 }	 					
		 	 		
		
		/* Formular */
		
		$tb->__set("tb_text", "");
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 30);
		$tb->__set("cssclass", "toolbar1");
		$tb->__set('homelink', false);
		$tb->__set("title", _SETTINGS);
		$tb->__set("toolbarfixed", false);

		$tb->addToolbar("save");
		$tb->addToolbar("accept");
		$tb->addToolbar("preview");

		$tb->addToolbar("cpanel");
		
		$tb->add("","hidden","act","config");
		$tb->add("","hidden","slider[width]","1024");
		
		$slidertypes=pmxSlider_array();
		//$slidertypes=array_flip($slidertypes);
		$tb->add("","select","slider[type]",$slider['type'],mxText("_TYPE"),mxText("_TYPE_TEXT"),1,$slidertypes);
		$tb->add("","range","slider[delay]",$slider['delay'],_DELAY,_DELAY_INFO,1,array("min"=>1000,"max"=>20000,"step"=>100));
		$tb->add("","range","slider[duration]",$slider['duration'],_DURATION,_DELAY_INFO,1,array("min"=>1000,"max"=>20000,"step"=>100));
		//$tb->add("","number","slider[width]",$slider['width'],_WIDTH,"",5,array("min"=>100,"max"=>2000,"step"=>10));
		$tb->add("","number","slider[height]",$slider['height'],_HEIGHT,"",5,array("min"=>100,"max"=>2000,"step"=>10));
		$tb->add("","yesno","slider[autoPlay]",$slider['autoPlay'],_AUTOPLAY,"",5,5);
		$tb->add("","yesno","slider[showTitle]",$slider['showTitle'],_SHOWTITLE,"",5,5);
		
		$form= $tb->Show();
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->init_path(__FILE__);

		/* hier die Ausgabefelder angeben */
		$credits= mxcredit_shortinfo_string("modules".DS . $module_name. DS."setup.pmx.php");

		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info', 'module_name','error','credits'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.config.html');

		mxIncludeFooter();		
	}
	/**
	 *  edit 
	 *  
	 *  @param [in] $act 
	 *  @param [in] $id  
	 *  @return 
	 *  
	 *  Date: 2021-03-09T11:19:07 
	 *  created by : Olaf Herfurth 
	 */
	 
	function edit($act,$id=0)
	{
		global $module_name;
		$prefix=pmxBase::prefix();
		$error="";
		$redirectflag=false;
		
		$info=$module_name;
		$form="";
		$tb = load_class('AdminForm', "adminFormMain");
		$record=$this->_default_record();
		//$record['position']=99;
		if ($id>0) {
			$sql = "SELECT * FROM `".$this->_tablename."` WHERE nr='".$id."'";
			$record=sql_fetch_assoc(sql_query($sql));
		}
		//mxDebugFuncVars($record);
		/* Auswertung Formular */
		
		 switch (pmxAdminForm::CheckButton()) {
			case "cpanel":

				mxRedirect("admin.php?op=$module_name");
			break;
			case "save":
				$redirectflag=true;
			case "accept":
				$record=$_POST['record'];
				//$this->config['records'][$id]=$record;
				//$config = load_class('Config',$module_name);
				;
				$set="	title='".mxAddSlashesForSQL($record['title'])."',
						nr='".intval($record['nr'])."',
						subtitle='".mxAddSlashesForSQL($record['subtitle'])."',
						url='".mxAddSlashesForSQL($record['url'])."',
						link_type='".intval($record['link_type'])."',
						active='".intval($record['active'])."',
						position='".intval($record['position'])."',
						image='".mxAddSlashesForSQL($record['image'])."'";
				$sWhere=" WHERE nr='".$id."'" ;
				
				if (intval($record['nr'])>0) {
					/* update */
					$sql="UPDATE `".$this->_tablename."` Set ".$set.$sWhere;
					sql_query($sql);
					} else {
					/* neu */
					$sql="INSERT INTO `".$this->_tablename."` Set ".$set;
					sql_query($sql);
					$record['nr']=sql_insert_id();
					$this->_renumPosition();
					
				}
				
				//$config->setSection($module_name,$this->config);
				if ($redirectflag) mxRedirect("admin.php?op=$module_name", _CHANGESAREOK, 0);
			break;
			
		 }	 		
		
		/* Formular */
		
		$tb->__set("tb_text", "");
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 30);
		$tb->__set("cssclass", "toolbar1");
		$tb->__set('homelink', false);
		$tb->__set("title", ($id>0)?_EDIT:_NEW);
		$tb->__set("toolbarfixed", false);
		
		$tb->addToolbar("save");
		$tb->addToolbar("accept");
		$tb->addToolbar("cpanel");
		
		$tb->add("","hidden","act","edit");
		$tb->add("","hidden","record[nr]",$record['nr']);
		$tb->add("","hidden","record[position]",$record['position']);
		
		$tb->add("","input","record[title]",$record['title'],mxText("_TITLE"),"",60,255);
		$tb->add("","input","record[subtitle]",$record['subtitle'],mxText("_SUBTITLE"),"",60,255);
		//$tb->add("","input","record[image]",$record['img'],mxText("_PICTURE"),"",60,255);
		$tb->add("","input","record[url]",$record['url'],mxText("_LINK"),"",60,255);
		$urltypes=array("_blank"=>"1","_self"=>"0","_parent"=>"2");
		$tb->add("","select","record[link_type]",$record['link_type'],mxText("_TARGET"),"",1,$urltypes);
		$tb->add("","yesno","record[active]",$record['active'],mxText("_ACTIVE"),"",1);
		$tb->add("","filebrowse","record[image]",$record['image'],mxText("_PICTURE"),mxText("_PICTURE_TEXT"),0,array("showimage"=>true,"width"=>"300px"));
		// $tb->add("","html",
		
		// "<a href='".$record['image']."' rel='pretty[slider]' title='".mxStripSlashes($record['title'])."'><img src='".$record['image']."' style='width:200px;max-height:200px;' /></a>",

		// );
		// <img src='".$record['image']."' style='width:200px;max-height:300px;' />"
		$form= $tb->Show();
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->init_path(__FILE__);

		$credits= mxcredit_shortinfo_string("modules".DS . $module_name. DS."setup.pmx.php");

		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info', 'module_name','error','credits'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.config.html');

		mxIncludeFooter();		
	}

	function delete($act,$id=array())
	{
		global $module_name;
		$prefix=pmxBase::prefix();
		$error="";
		$redirectflag=false;
		
		$info=$module_name;
		$form="";
		$tb = load_class('AdminForm', "adminFormMain");
		$record=$this->_default_record();
		
		//mxDebugFuncVars($record);
		/* Auswertung Formular */
		if ($act=="delete") {
		 switch (pmxAdminForm::CheckButton()) {
			case "cpanel":
			case "cancel":
				mxRedirect("admin.php?op=$module_name");
			break;

			case "delete":
				$records=$_POST['cid'];
				/* hier records löschen */
				foreach($records as $dummy=>$record){
					//$cid=$record['nr'];
					sql_query("DELETE FROM `".$this->_tablename."` WHERE nr='".$record."'");
				}
				$this->_renumPosition();
				unset ($records);
				mxRedirect("admin.php?op=$module_name", _IMGDEL_INFO, 1);
			break;
			
		 }	 		
		}
		/* Formular */
		
		$tb->__set("tb_text", "");
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 30);
		$tb->__set("cssclass", "toolbar1");
		$tb->__set('homelink', false);
		$tb->__set("title", _DELETE);
		$tb->__set("toolbarfixed", false);
		$tb->__set("description", _IMGDEL_WARNING);
		
		$tb->addToolbar("deletex");
		$tb->addToolbar("cancel");
		$tb->addToolbar("cpanel");
		
		$tb->add("","hidden","act","delete");

		/* Daten holen */
        $fieldname=array(
            array("name"=>mxText('_TITLE'),"attr"=>"style='min-width:100px'"),
            array("name"=>mxText('_SUBTITLE'),"attr"=>"style='width:auto'"),
            array("name"=>mxText('_PICTURE'),"attr"=>"style='min-width:100px'"),

            array("name"=>mxText("_LINK"),"attr"=>"style='width:100px'"),
            
            );		
		$cids=implode(",",$id);
		$records=sql_query("SELECT * FROM `".$this->_tablename."` WHERE nr IN(".$cids.")");
		
		$values=array();

		foreach ($records as $record)
		{
			$record1=$this->_default_record();
			$value=array_merge($record1,$record);
		   $values[$value['nr']]=array(
				mxStripSlashes($value['title']),
				mxStripSlashes($value['subtitle']),
				mxStripSlashes($value['image']),
				mxStripSlashes($value['link']),
				
			);
		}
		
		$tb->add("","table",$fieldname,$values,"","",0,array("preselectall"=>true));
		
		$form= $tb->Show();
				
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->init_path(__FILE__);

		$credits= mxcredit_shortinfo_string("modules".DS . $module_name. DS."setup.pmx.php");

		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info', 'module_name','error','credits'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.config.html');

		mxIncludeFooter();		
	}
	
	function preview()
	{
		
		$mypath=PMX_MODULES_PATH . $this->_modul .DS;

		$tb = load_class('AdminForm', "adminFormMain");

		/* Auswertung Formular */
		 switch (pmxAdminForm::CheckButton()) 
		 {
			case "back":
				mxRedirect("admin.php?op=$module_name","",0);
			break;
			case "config":
				$this->settings($act);
				die();
				break;
		 }
		 
		$tb->__set("tb_text", "");
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 30);
		$tb->__set("cssclass", "toolbar1");
		$tb->__set('homelink', false);
		$tb->__set("title", _PREVIEW);
		$tb->__set("toolbarfixed", false);

		//$tb->addToolbar("save");
		
		$tb->addToolbar("config");

		$tb->addToolbar("cpanel");
				
		$form= $tb->Show();

		//ob_start();
		$content="";
		include_once($mypath."blocks".DS."block-Slider.php");
		
		//ob_end_clean();
		
		$block=$form.$content;
		$module_name=$this->_modul;
		
		$info = $this->_modul;
		
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->init_path(__FILE__);

		/* hier die Ausgabefelder angeben */

		/* Variablen an das Template uebergeben */
		$template->assign(compact( 'info', 'module_name','block'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.preview.html');

		mxIncludeFooter();				
		
	}
	
	private function _updatePosition($nr,$position)
	{
			$qry ="UPDATE ".$this->_tablename." SET position='".intval($position)."'";
			$qry .=" WHERE nr=".intval($nr)."";
			//mxDebugFuncVars($qry);
			if ($qry) pmxDatabase::system_query($qry);		
	}

	private function _activate($nr)
	{
			$qry ="UPDATE ".$this->_tablename." SET active='1'";
			$qry .=" WHERE nr=".intval($nr)."";
			//mxDebugFuncVars($qry);
			if ($qry) pmxDatabase::system_query($qry);		
	}	

	private function _deactivate($nr)
	{
			$qry ="UPDATE ".$this->_tablename." SET active='0'";
			$qry .=" WHERE nr=".intval($nr)."";
			//mxDebugFuncVars($qry);
			if ($qry) pmxDatabase::system_query($qry);		
	}	

	private function _renumPosition()
	{
			$qry ="SELECT nr,position FROM ".$this->_tablename." ORDER by position ASC";
			//mxDebugFuncVars($qry);
			$result= pmxDatabase::system_query($qry);	
			$pos=1;
			while ($record=sql_fetch_assoc($result))
			{
				$this->_updatePosition($record['nr'],$pos);
				$pos++;
			}
	}

	private function _default_config()
	{
		$defconf=array(
			'type'=>'6',
			'duration'=>1500,
			'delay'=>6000,		// in ms		Zeit zwischen Bildwechsel
			'width'=>1950,
			'height'=>600,
			'autoPlay'=>true,		// animation automatisch starten
			'showTitle'=>true,	// Titel/Text anzeigen	
			
		);

		$slider=array('slider'=>$defconf,
					'records'=>array(),
					);
		
		return $slider;
	}
	
	private function _default_record()
	{
		$record=array("nr"=>0,
				"title"=>"",
				"subtitle"=>"",
				"image"=>"",
				"url"=>"",
				"link_type"=>"0",
				"active"=>0,
				"file"=>false,
				"position"=>999,
				);	
		return $record;
	}
	
	

}




if (!isset($act)) $act = "";
if (!isset($id)) $id = 0;


$tmp = new mxSlider($act,$id);
unset ($tmp);


?>